#!/usr/bin/python

import time

import RoboPiLib  as RoboPi
import RoboPiDefs as isa

# variable definitions

sonar = 0	# HC-SR04 sersor

lfwd = 12	# L9901S A-1A
lrev = 13	# L9901S A-1B
rfwd = 14	# L9901S B-1B
rrev = 15	# L9901S B-1A

# helper functions

def setmotors(lf,lr,rf,rr):
    RoboPi.analogWrite(lfwd,lf)
    RoboPi.analogWrite(lrev,lr)
    RoboPi.analogWrite(rfwd,rf)
    RoboPi.analogWrite(rrev,rr)

# wait specified number of seconds
def wait(secs):
    done = time.time()+secs
    while time.time() < done:
        time.sleep(0.1)

# stop all motors (brake)
def stop():
    print "Stop"
    setmotors(0,0,0,0)
    
# go forward for specified number of seconds
def forward(speed,secs):
    stop()
    print "Foward"
    setmotors(speed,0,speed,0)
    wait(secs)

# go backward for specified number of seconds
def reverse(speed,secs):
    stop()
    print "Reverse"
    setmotors(0,speed,0,speed)
    wait(secs)

# turn left for specified number of seconds
def turn_left(speed,secs):
    stop()
    print "Left Turn"
    setmotors(0,0,speed,0)
    wait(secs)

# turn right for specified number of seconds
def turn_right(speed,secs):
    stop()
    print "Right Turn"
    setmotors(speed,0,0,0)
    wait(secs)

# spin left specified number of seconds
def spin_left(speed,secs):
    stop()
    print "Spin Left"
    setmotors(0,speed,speed,0)
    wait(secs)

# spin right for specified number of seconds
def spin_right(speed,secs):
    stop()
    print "Spin Right"
    setmotors(speed,0,0,speed)
    wait(secs)

# main program

RoboPi.RoboPiInit("/dev/ttyAMA0",115200);

for motor in range(lfwd,rrev+1):
    RoboPi.pinMode(motor,isa.OUTPUT) # set motor control pins to output

forward(255,2)
reverse(255,2)
turn_left(255,2)
turn_right(255,2)
spin_left(255,2)
spin_right(255,2)
stop()

print "Done moving!"

for i in range(0,1000):
    print RoboPi.readDistance(sonar)
  
print "Exiting..."
  
RoboPi.RoboPiExit()
